"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopOverSkin = PopOverSkin;

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _react = _interopRequireDefault(require("@tippyjs/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _popper = _interopRequireDefault(require("popper.js"));

var _react2 = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PopOverWrapper =
/*#__PURE__*/
(0, _react2.forwardRef)(function (props, ref) {
  return (
    /*#__PURE__*/
    // eslint-disable-next-line jsx-a11y/no-noninteractive-tabindex
    _react2["default"].createElement("span", {
      className: props.className,
      tabIndex: "0",
      ref: ref
    }, props.children)
  );
});

function PopOverSkin(props) {
  var allowHTML = props.allowHTML,
      children = props.children,
      content = props.content,
      contentClassName = props.contentClassName,
      isVisible = props.isVisible,
      theme = props.theme,
      themeId = props.themeId,
      themeOverrides = props.themeOverrides,
      themeVariables = props.themeVariables,
      tippyProps = _objectWithoutProperties(props, ["allowHTML", "children", "content", "contentClassName", "isVisible", "theme", "themeId", "themeOverrides", "themeVariables"]);

  return (
    /*#__PURE__*/
    _react2["default"].createElement(_react["default"], _extends({}, tippyProps, {
      visible: isVisible,
      content: (0, _isString2["default"])(content) && allowHTML ?
      /*#__PURE__*/
      _react2["default"].createElement("span", {
        dangerouslySetInnerHTML: {
          __html: content
        }
      }) : content,
      className: (0, _classnames["default"])([theme[themeId].root]),
      theme: "polymorph",
      plugins: [{
        // Makes it possible to pass themeVariables props to PopOvers
        name: 'cssVariables',
        defaultValue: {},
        fn: function fn(instance) {
          return {
            onCreate: function onCreate() {
              var cssVariables = instance.props.cssVariables;
              Object.keys(cssVariables).forEach(function (key) {
                instance.popper.style.setProperty(key, cssVariables[key]);
              });
            }
          };
        }
      }],
      popperOptions: {
        modifiers: [{
          name: 'computeStyles',
          options: {
            // Necessary to avoid sub-pixel rendering issues with arrows
            gpuAcceleration: false // true by default

          }
        }]
      },
      cssVariables: themeVariables
    }),
    /*#__PURE__*/
    _react2["default"].createElement(PopOverWrapper, {
      className: contentClassName
    }, children))
  );
}
//# sourceMappingURL=PopOverSkin.js.map